/***************************************************************/
//
//
//		DirectX	[ meshrenderer3d.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/25
/*---------------------------------------------------------------
Update : 2017/5/25
			Create Header File -> meshrenderer3d.h.h 
 			< Add Class Function >
				MESHRENDERER3D->Constructor
				MESHRENDERER3D->Destructor
				MESHRENDERER3D->SetComponent ( static member )
				MESHRENDERER3D->Render


Update : 2017/5/25



/*-------------------------------------------------------------*/
#ifndef _MESHRENDERER3D_H_

#define _MESHRENDERER3D_H_



/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include "render_interface.h"


class ModelInterface;
class Matrix;


/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class MeshRenderer3D Using MeshRenderer3D
class MeshRenderer3D : public RenderInterface
{
public:
	
	MeshRenderer3D(							// MeshRenderer3D Constructor
		ModelInterface**  pMeshObj,
		Matrix*        	pMatrix );
	~MeshRenderer3D( );						// MeshRenderer3D Destructor

	static MeshRenderer3D* SetComponent( 		// MeshRenderer3D Create Instance Class
		ModelInterface**  pMeshObj,
		Matrix*        	pMatrix );

	void Render( void );					// MeshRenderer3D RenderObject


private:

	// Member Variable
	ModelInterface**    pMeshObj;
	Matrix*		        pMatrix;


};


#endif	//	_MESHRENDERER3D_H_


