/***************************************************************/
//
//
//		DirectX	[ meshrenderergrid.h ]
//
//											Author	kazuki tanaka
//											Date	2017 6/22
/*---------------------------------------------------------------
Update : 2017/6/22
			Create Header File -> meshrenderergrid.h.h 
 			< Add Class Function >
				MeshRendererGrid->Constructor
				MeshRendererGrid->Destructor
				MeshRendererGrid->Create ( static member )
				MeshRendererGrid->Init
				MeshRendererGrid->Uninit
				MeshRendererGrid->Update
				MeshRendererGrid->Draw

Update : 2017/6/22



/*-------------------------------------------------------------*/
#ifndef _MESHRENDERERGRID_H_

#define _MESHRENDERERGRID_H_

/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include "render_Interface.h"

class VertexBuffer;
class Matrix;

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class MeshRendererGrid Using MeshRendererGrid
class MeshRendererGrid : public RenderInterface
{
public:
	
	MeshRendererGrid( 							// MeshRendererGrid constructor
		VertexBuffer** ppVtxBuf,
		Matrix* pMtx );
	~MeshRendererGrid( );						// MeshRendererGrid destructor

	static MeshRendererGrid* SetComponent( 		// MeshRendererGrid Create Instance Class
		VertexBuffer** ppVtxBuf,
		Matrix* pMtx );
	
	void Render( void );					// MeshRendererGrid Draw
	

private:

	// Member Variable
	VertexBuffer** ppVtxBuf;
	Matrix* pMtx;
	

};

#endif	//	_MESHRENDERERGRID_H_


