/***************************************************************/
//
//
//		DirectX	[ playercontrol.h ]
//
//											Author	kazuki tanaka
//											Date	2017 6/22
/*---------------------------------------------------------------
Update : 2017/6/22
			Create Header File -> playercontrol.h.h 
 			< Add Class Function >
				PlayerControl->Constructor
				PlayerControl->Destructor
				PlayerControl->Create ( static member )
				PlayerControl->Init
				PlayerControl->Uninit
				PlayerControl->Update
				PlayerControl->Draw

Update : 2017/6/22



/*-------------------------------------------------------------*/
#ifndef _PLAYERCONTROL_H_

#define _PLAYERCONTROL_H_


/*---------------------------------------------------------------
	include File
---------------------------------------------------------------*/

#include "vector3.h"
#include "color.h"

class GameObject;
class CInput;

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class PlayerControl Using PlayerControl
class PlayerControl
{
public:
	PlayerControl( const Vector3& pos );	// PlayerControl Constructor
	~PlayerControl( );						// PlayerControl Destructor

	static PlayerControl* Create( const Vector3& pos );	// PlayerControl Create Instance Class

	void Init( void );						// PlayerControl Initialize
	void Uninit( void );					// PlayerControl Uninitialize
	void Update( void );					// PlayerControl Update

	int GetCurrent( void )
	{
		return current;
	}

private:

	// Member Variable
	GameObject* player;
	CInput* input;
	Vector3 pos;
	Color color;
	int current;


};


#endif	//	_PLAYERCONTROL_H_


