/***************************************************************/
//
//
//		DirectX	[ procmethod.h ]
//
//											Author	kazuki tanaka
//											Date	2017 6/13
/*---------------------------------------------------------------
Update : 2017/6/13
			Create Header File -> procmethod.h.h 
 			< Add Class Function >
				ProcMethod->Constructor
				ProcMethod->Destructor
				ProcMethod->Create ( static member )
				ProcMethod->Init
				ProcMethod->Uninit
				ProcMethod->Update
				ProcMethod->Draw

Update : 2017/6/13



/*-------------------------------------------------------------*/
#ifndef _PROCMETHOD_H_

#define _PROCMETHOD_H_

/*---------------------------------------------------------------
	Difnition
---------------------------------------------------------------*/

typedef void* (*MethodFunc)(HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);

typedef void* Method;

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class ProcMethod Using ProcMethod
namespace ProcMethod
{

	// msg method
	void DialogInstance( unsigned int id,__in_opt DLGPROC lpDialogFunc );
	void PopUpMenuInstance( unsigned int id, const POINT& point );
	void SaveFileDialog( const std::string& filename, unsigned int flag );
	void OpenFileDialog( unsigned int flag );

	// CallbackMethod
	Method CloseWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	Method CreateWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	Method DestoryWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);

	Method CommandWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);

	Method SizeWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	//Method ResizeWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);

	Method KeydownWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	Method DropFileWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	
	Method LBtnDownWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	Method RBtnDownWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	Method LBtnReleaseWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
	Method RBtnReleaseWinMsg( HWND& hWnd,UINT& uMsg,WPARAM& wParam,LPARAM& lParam);
};


#endif	//	_PROCMETHOD_H_


